#ifndef VEH_MEASURE_H
#define VEH_MEASURE_H

#include "base_measure.h"

//#ifndef EIGEN_DONT_ALIGN_STATICALLY
//#define EIGEN_DONT_ALIGN_STATICALLY
//#endif

namespace Localization {
namespace Ego {

class VehMeasure : public BaseMeasure {
public:
    VehMeasure() = delete;
    VehMeasure(const VehMeasure &) = delete;
    VehMeasure & operator=(const VehMeasure &) = delete;
    VehMeasure(const MeasurementType &mType, const VehInfo &vehInfo);
    void CheckValid();
    // ****** function ****** //
    bool Update(const State &state, State &nextState) override;
    bool UpdateStateWheel(const State &state, State &nextState, const Eigen::VectorXd &innov,
          const Eigen::MatrixXd &mH);
    Eigen::VectorXd MeasurementEquation(const State &state) const;
    bool IsStatic();
    void ObserveVeh(const State &state, State &nextState, Eigen::VectorXd &innov,
                                          Eigen::MatrixXd &mH);
    unsigned int flCnt_;
    unsigned int frCnt_;
    unsigned int rlCnt_;
    unsigned int rrCnt_;
    unsigned int staticCunt_;
    double yawRate_;
    double wheelSpeed_;
    Eigen::Vector3d vm_ = Eigen::Vector3d::Zero();
    Eigen::Vector3d wm_ = Eigen::Vector3d::Zero();
    Eigen::Vector3d accm_ = Eigen::Vector3d::Zero();

    double wheelVelocityVarX_ = 0.05 * 0.05;
    double wheelVelocityVarY_ = 0.1 * 0.1;
    double wheelVelocityVarZ_ = 0.2 * 0.2;
    double wheelAngleRateVar_ = 0.001 * 0.001;
    double wheelAccVar_ = 0.1 * 0.1;

    static double latestUpdateTime_;
}; // class VehMeasure

} // namespace Ego
} // namespace Localization
#endif
